"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
const graphql_1 = require("graphql");
class TypeScriptSelectionSetToObject extends graphql_codegen_visitor_plugin_common_1.SelectionSetToObject {
    constructor(_scalars, _schema, _convertName, _addTypename, _immutableTypes, _parentSchemaType, _selectionSet) {
        super(_scalars, _schema, _convertName, _addTypename, _parentSchemaType, _selectionSet);
        this._immutableTypes = _immutableTypes;
    }
    createNext(parentSchemaType, selectionSet) {
        return new TypeScriptSelectionSetToObject(this._scalars, this._schema, this._convertName, this._addTypename, this._immutableTypes, parentSchemaType, selectionSet);
    }
    clearOptional(str) {
        if (str.startsWith('Maybe')) {
            return str.replace(/^Maybe<(.*?)>$/i, '$1');
        }
        return str;
    }
    formatNamedField(name) {
        return this._immutableTypes ? `readonly ${name}` : name;
    }
    wrapTypeWithModifiers(baseType, type) {
        if (graphql_1.isNonNullType(type)) {
            return this.clearOptional(this.wrapTypeWithModifiers(baseType, type.ofType));
        }
        else if (graphql_1.isListType(type)) {
            const innerType = this.wrapTypeWithModifiers(baseType, type.ofType);
            return `Maybe<${this._immutableTypes ? 'ReadonlyArray' : 'Array'}<${innerType}>>`;
        }
        else {
            return `Maybe<${baseType}>`;
        }
    }
}
exports.TypeScriptSelectionSetToObject = TypeScriptSelectionSetToObject;
//# sourceMappingURL=ts-selection-set-to-object.js.map